###############################################################################
#
# File:         PSL:Makefile
# Description:  Top level makefile for PSL.
# Author:       Harold Carr and Leigh Stoller.
# Created:      04-Feb-87
#
# (c) Copyright 1987, University of Utah, all rights reserved.
###############################################################################
# Revisions:
# 
###############################################################################

PROGRAMS = bare-psl psl pslcomp oload

all: bpsl pnkl utilities compiler make-bare-psl make-psl make-pslcomp
	echo "PSL binaries rebuilt"

executables: make-bare-psl make-psl make-pslcomp

pnkl:
	mms $(PXNK)Makefile
	mms $(PNK)Makefile

compiler:
	mms $(PXC)Makefile
	mms $(PC)Makefile

utilities:
	mms $(PXu)Makefile
	mms $(PU) Makefile

bpsl: 
	mms $(PXK)Makefile

bare-psl: bpsl pnkl make-bare-psl

make-bare-psl:
	@pdist:make_bare_psl

psl: bare-psl utilities make-psl

make-psl:
	@pdist:make_psl

pslcomp: bare-psl compiler utilities make-pslcomp

make-pslcomp:
	@pdist:make_pslcomp

rlisp: bare-psl compiler utilities make-rlisp

# In order to rebuild the system, pslcomp and MACHINE-cross must exist.
clean:

# End of file.
