%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXC:COMPILER.SL
% Description:  PSL Compiler.
% Author:       Harold Carr & Leigh Stoller
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
% This file loads in all the compiler modules for Cray-t3d.
%

(load fastlink)

(load datamachine pass-1 pass-2-3 comp-decls pass-1-lap Cray-t3d-lap
      Cray-t3d-cmac Cray-t3d-comp registers Cray-t3d-instrs lapopt
	faslout Cray-t3d-spec big-faslend)

(setq *writingfaslfile nil)
(setq *writingasmfile nil)

(de putbittable (baseaddress bitoffset value2)
  (prog (m b c)
        (setq b
              (iland (byte baseaddress (setq m (ilsh bitoffset -2)))
                     (ilsh (idifference -1 (itimes2 3 256))
                      (idifference -2
                       (setq c (itimes2 (field bitoffset 62 2) 2))))))
        (putbyte baseaddress m (if (eq value2 0)
                   b
                   (ilor b (ilsh value2 (idifference 6 c)))))))

(de makerelocword (reloctag relocinf)
  (wplus2 (wshift reloctag 62) (field relocinf 2 62)))

(de makerelocinf (reloctag relocinf)
  (wplus2 (wshift reloctag 54) (field relocinf 10 54)))


(remprop 'bittable 'opencode)
(remprop 'putbittable 'opencode)
(remprop 'wquotient 'openfn)

(de updatebittable (numberofentries firstentry)
  (when *writingfaslfile
   (if (eq numberofentries 4) % "an instruction"
    (progn
    (putbittable bittablebase* (lxor bittableoffset* 4) firstentry)
    (setq bittableoffset* (iadd1 bittableoffset*))
    (for (from i 2 numberofentries 1)
         (do (progn (putbittable bittablebase* (lxor 4 bittableoffset*) 0)
                    (setq bittableoffset* (iadd1 bittableoffset*))))))
                  % "NO instruction"
    (putbittable bittablebase* bittableoffset* firstentry)
    (setq bittableoffset* (iadd1 bittableoffset*))
    (for (from i 2 numberofentries 1)
         (do (progn (putbittable bittablebase* bittableoffset* 0)
                    (setq bittableoffset* (iadd1 bittableoffset*))))))
    (when (igreaterp bittableoffset* maxfasloffset*)
      (fatalerror "BPS exhausted during FaslOut; output file too large"))))

% End of file.
