%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PVC:SYS-DM.SL
% Title:        Lisp item constructors & selectors for Sun 4 Syslisp
% Author:       Eric Benson, University of Utah
% Created:	10-Jul-81
% Modified:     24 Feb 1984 1745-PST
% Status:       Experimental (Do Not Distribute)
% Mode:         Lisp
% Package:      SYSLISP
%
% Copyright (c) 1983, 1984 Hewlett-Packard
% Copyright (c) 1981 University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 20-Jul-84 9:00 (Brian Beach)
%  Added RIGHTHALF macro.
% 24 Feb 1984 1743-PST (Cris Perdue)
%  Moved values of constants to vax sys-consts.
% 23-Nov-83 (Brian Beach)
%  Translated from RLISP to LISP.  Made macros more readable by using
%  substitution macros.  
%
% june 8 1988 (yamamoto and burdorf)
%   Redefined symfnc for sparc architecture
% December 8 1988 Winfried Neun, ZIB Berlin
%   Redefined symfnc for sparc architecture
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Retrieve the address stored in the function cell

(ds SymFnc (index)
  (let ((addr (wplus2 (wtimes2 index addressingunitsperfunctioncell) symfnc)))
       (getmem  addr)))

% Can't really do PutSymFnc

(dm PutSymFnc (U) 
    '(StdError 'PutSymFnc does not exist on the Sun 4))

 % access to SYMget vector

(dm Symget (U)
        `(wgetv Symget ,(cadr U)))

% Macros for building stack pointers, no-ops on the Sun 4

(ds MakeStackPointerFromAddress (x) 
  x
  )

(ds MakeAddressFromStackPointer (x) 
  x
  )

(RemProp 'AdjustStackPointer 'OpenFn)

(ds AdjustStackPointer (stack-pointer offset) 
  (wdifference stack-pointer offset)
  )

(ds righthalf (x)
  (field x 16 16)
  )
