%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXC:COMPILER.SL
% Description:  PSL Compiler.
% Author:       Harold Carr & Leigh Stoller
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
% This file loads in all the compiler modules for 370.
%

(push 'sys-consts options*)
(push 'sys-dm options*)
(push 'p1-decls  options*)

(load datamach
      sysconst
      sysdm
      pass1
      p1decls
      pass2 pass3
      compdecl
      xaopernd
      pass1lap
      xalap xainstrs xacmacs xacomp xaformat xaldep faslout xaspec)

(setq *writingfaslfile nil)
(setq *writingasmfile nil)
(remprop 'wquotient 'openfn)
(remprop 'wtimes2 'openfn)


(defcmacro *ALLOC
        ((Freep) (using "*" (reg r15)))
        (       (STM (Reg r14) (reg r12) (displacement (reg r13) 12))
	 	(*move (reg st) (reg r2))
                (*move (plus2 96 ArgOne) (reg r0))
                (SLR (reg st) (reg r0))
                (st  (reg r13)  (displacement (reg r2) 8))
                (st  (reg r2)  (displacement (reg r13) 4))
                (Balr (reg r3) (reg r0))
                (Using "*" (reg r3) (reg r2))
% should be optimize some day
                (la (reg r2) (displacement (reg r3) 2048))
                (la (reg r2) (displacement (reg r2) 2048))))

(DefCMacro *DeAlloc
         ((FreeP))
         (     (L  (reg r13) (displacement (reg r13) 4))
                (L (reg r14) (displacement (reg r13) 12))
                (LM (reg r2) (reg r3) (displacement (reg r13) 28))))
% End of file.
