%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PXNK:SCAN-TABLE.SL                                            
% Title:          Lisp character table for VAX UNIX/HPUX200                
% Author:         Eric Benson                                              
% Created:        27 November 1981                                         
% Modified:       14-Jan-85 (Vicki O'Day)
% Status:         Experimental                                             
% Mode:           Lisp                                                     
% Package:        Kernel                                                   
%
% (c) Copyright 1983,  Hewlett-Packard Company, all rights reserved.       
% Copyright (c) 1981 Eric Benson                                           
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                          
% Revisions:                                                               
%                                                                          
% 3- May-90 (Herbert Melenk)
%  Changed entry 26 (MS-DOS EOF) from 10 to 11
% 14-Jan-85 (Vicki O'Day)
%  Changed startuptime to a loadtime.
% 27-Feb-84 16:47:08 (RAM)                                                 
%  Changed File and Title entries in header.                               
% 2-Dec-83  16:00:00 (Brian Beach)                                         
%   Translated from Rlisp to Lisp.                                         
%                                                                          
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                                                           
%                                                                          
% Edit by Cris Perdue, 24 Mar 1983 1748-PST                                
% Changed the "put EOF" to be a STARTUPTIME form                           
% LispDipthong -> LispDiphthong                                            
(fluid '(lispscantable* currentscantable*))

(setq lispscantable* 
      '[17 10 10 10 11 10 10 10 10 17 17 10 17 17 10 10 10 10 10 10 10 10 
        10 10 10 10 11 10 10 10 10 10 17 14 15 10 10 12 10 11 11 11 10 19 
        10 18 20 10 0 1 2 3 4 5 6 7 8 9 10 10 10 10 10 10 10 10 10 10 10 
        10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 
        11 16 11 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 
        10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 lispdiphthong])

(setq currentscantable* lispscantable*)

% Done as "startuptime" because "char" is available at compile             
% time but not necessarily init time /csp                                  
(loadtime (put 'eof 'charconst (char (cntrl z))))

