%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:TIMC.SL
% Description:  Get run time in milliseconds.                              
% Author:       Leigh Stoller
% Created:      22-Dec-86
% Package:      
% RCS $Header: $
%
% (c) Copyright 1986, University of Utah.
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Revisions:
%
% 22-Dec-86 (Leigh Stoller)
%  Copied from vax nonkernel directory.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (load sys-macros))
(on fast-integers)
 
(compiletime (fluid '(*timescale1 *timescale2)))
 
(setq *timescale1 1)

(setq *timescale2 1)

(declare-warray timebuffer size 4)

% Get run-time in milliseconds. Left in for compatability
(de time () 
  (sys2int (timc)))

% compute timc := systime *timescale2 / *timescale1

(de timc ()
  (e_timc timebuffer)
  (if (wgreaterp *timescale2 *timescale1)
       % increase 
      (wquotient (wtimes2 *timescale2 (wgetv timebuffer 0))  *timescale1)
      (wtimes2 *timescale2 (wquotient (wgetv timebuffer 0) *timescale1))
))

(off fast-integers)
